

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>pywws.Template &mdash; pywws v12.10 documentation</title>
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '12.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <link rel="shortcut icon" href="../_static/pywws_logo.ico"/>
    <link rel="top" title="pywws v12.10 documentation" href="../index.html" />
    <link rel="up" title="Python programs and modules" href="index.html" />
    <link rel="next" title="pywws.Forecast" href="pywws.Forecast.html" />
    <link rel="prev" title="pywws.WindRose" href="pywws.WindRose.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="pywws.Forecast.html" title="pywws.Forecast"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="pywws.WindRose.html" title="pywws.WindRose"
             accesskey="P">previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" accesskey="U">Python programs and modules</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="pywws-template">
<h1>pywws.Template<a class="headerlink" href="#pywws-template" title="Permalink to this headline">¶</a></h1>
<div class="section" id="introduction">
<h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<p>This is probably the most difficult to use module in the weather station software collection. It generates text files based on a &#8220;template&#8221; file plus the raw, hourly, daily &amp; monthly weather station data. The template processing goes beyond simple substitution of values to include loops, jumps forwards or backwards in the data, processing of the data and substitution of missing values.</p>
<p>A template file can be any sort of text file (plain text, xml, html, etc.) to which &#8220;processing instructions&#8221; have been added. These processing instructions are delimited by hash (&#8216;#&#8217;) characters. They are not copied to the output, but cause something else to happen: either a data value is inserted or one of a limited number of other actions is carried out.</p>
<p>Before writing your own template files, it might be useful to look at some of the examples in the example_templates directory.</p>
</div>
<div class="section" id="processing-instructions">
<h2>Processing instructions<a class="headerlink" href="#processing-instructions" title="Permalink to this headline">¶</a></h2>
<blockquote>
<ul>
<li><p class="first"><tt class="docutils literal"><span class="pre">##</span></tt>: output a single &#8216;#&#8217; character.</p>
</li>
<li><p class="first"><tt class="docutils literal"><span class="pre">#monthly#</span></tt>: switch to &#8220;monthly&#8221; summary data. The index is reset to the most recent value.</p>
</li>
<li><p class="first"><tt class="docutils literal"><span class="pre">#daily#</span></tt>: switch to &#8220;daily&#8221; summary data. The index is reset to the most recent value.</p>
</li>
<li><p class="first"><tt class="docutils literal"><span class="pre">#hourly#</span></tt>: switch to &#8220;hourly&#8221; summary data. The index is reset to the most recent value.</p>
</li>
<li><p class="first"><tt class="docutils literal"><span class="pre">#raw#</span></tt>: switch to &#8220;raw&#8221; data. The index is reset to the most recent value.</p>
</li>
<li><p class="first"><tt class="docutils literal"><span class="pre">#timezone</span> <span class="pre">name#</span></tt>: convert all datetime values to time zone <tt class="docutils literal"><span class="pre">name</span></tt> before output. Permitted values for name are <tt class="docutils literal"><span class="pre">utc</span></tt> or <tt class="docutils literal"><span class="pre">local</span></tt>.</p>
</li>
<li><p class="first"><tt class="docutils literal"><span class="pre">#roundtime</span> <span class="pre">expr#</span></tt>: switch time rounding on or off, according to <tt class="docutils literal"><span class="pre">expr</span></tt>. When time rounding is on, 30 seconds is added to each time value used. This is useful if you are only printing out hours and minutes, e.g. with a &#8220;%H:%M&#8221; format, and want time values such as 10:23:58 to appear as &#8220;10:24&#8221;. Use <tt class="docutils literal"><span class="pre">&quot;True&quot;</span></tt> or <tt class="docutils literal"><span class="pre">&quot;False&quot;</span></tt> for expr.</p>
</li>
<li><p class="first"><tt class="docutils literal"><span class="pre">#jump</span> <span class="pre">count#</span></tt>: jump <tt class="docutils literal"><span class="pre">count</span></tt> values. The data index is adjusted by <tt class="docutils literal"><span class="pre">count</span></tt> hours or days. Negative values jump back in time.</p>
<p>It is a good idea to put jumps within a loop at the end, just before the <tt class="docutils literal"><span class="pre">#endloop#</span></tt> instruction. The loop can then terminate cleanly if it has run out of data.</p>
</li>
<li><p class="first"><tt class="docutils literal"><span class="pre">#goto</span> <span class="pre">date-time#</span></tt>: go to <tt class="docutils literal"><span class="pre">date-time</span></tt>. The data index is adjusted to the record immediately after <tt class="docutils literal"><span class="pre">date-time</span></tt>. This can be in UTC or your local time zone, according to the setting of <tt class="docutils literal"><span class="pre">timezone</span></tt>, and must exactly match the ISO date format, for example <tt class="docutils literal"><span class="pre">&quot;2010-11-01</span> <span class="pre">12:00:00&quot;</span></tt> is noon on 1st November 2010.</p>
<p>Parts of <tt class="docutils literal"><span class="pre">date-time</span></tt> can be replaced with strftime style % format characters to specify the current loop index. For example, <tt class="docutils literal"><span class="pre">&quot;%Y-%m-01</span> <span class="pre">12:00:00&quot;</span></tt> is noon on 1st of this month.</p>
</li>
<li><p class="first"><tt class="docutils literal"><span class="pre">#loop</span> <span class="pre">count#</span></tt>: start a loop that will repeat <tt class="docutils literal"><span class="pre">count</span></tt> times. <tt class="docutils literal"><span class="pre">count</span></tt> must be one or more.</p>
</li>
<li><p class="first"><tt class="docutils literal"><span class="pre">#endloop#</span></tt>: end a loop started by <tt class="docutils literal"><span class="pre">#loop</span> <span class="pre">count#</span></tt>. The template processing will go back to the line containing the <tt class="docutils literal"><span class="pre">#loop</span> <span class="pre">count#</span></tt> instruction. Don&#8217;t try to nest loops.</p>
</li>
<li><p class="first"><tt class="docutils literal"><span class="pre">#key</span> <span class="pre">fmt_string</span> <span class="pre">no_value_string</span> <span class="pre">conversion#</span></tt>: output a data value. <tt class="docutils literal"><span class="pre">key</span></tt> is the data key, e.g. <tt class="docutils literal"><span class="pre">temp_out</span></tt> for outdoor temperature. <tt class="docutils literal"><span class="pre">fmt_string</span></tt> is a printf-like format string (actually Python&#8217;s % operator) except for datetime values, when it is input to datetime&#8217;s <tt class="docutils literal"><span class="pre">strftime()</span></tt> method. <tt class="docutils literal"><span class="pre">no_value_string</span></tt> is output instead of <tt class="docutils literal"><span class="pre">fmt_string</span></tt> when the data value is absent, e.g. if the station lost contact with the outside sensor. <tt class="docutils literal"><span class="pre">conversion</span></tt> is a Python expression to convert the data, e.g. to convert wind speed from m/s to mph you could use <tt class="docutils literal"><span class="pre">&quot;x</span> <span class="pre">*</span> <span class="pre">3.6</span> <span class="pre">/</span> <span class="pre">1.609344&quot;</span></tt>.</p>
<p>All these values need double quotes &#8221; if they contain spaces or other potentially difficult characters. All except <tt class="docutils literal"><span class="pre">key</span></tt> are optional, but note that if you want to specify a conversion, you also need to specify <tt class="docutils literal"><span class="pre">fmt_string</span></tt> and <tt class="docutils literal"><span class="pre">no_value_string</span></tt>.</p>
</li>
<li><p class="first"><tt class="docutils literal"><span class="pre">#calc</span> <span class="pre">expression</span> <span class="pre">fmt_string</span> <span class="pre">no_value_string</span> <span class="pre">conversion#</span></tt>: output a value computed from one or more data items. <tt class="docutils literal"><span class="pre">expression</span></tt> is any valid Python expression, e.g. <tt class="docutils literal"><span class="pre">&quot;dew_point(data['temp_out'],</span> <span class="pre">data['hum_out'])&quot;</span></tt> to compute the outdoor dew point. <tt class="docutils literal"><span class="pre">fmt_string</span></tt>, <tt class="docutils literal"><span class="pre">no_value_string</span></tt> and <tt class="docutils literal"><span class="pre">conversion</span></tt> are as described above. Note that it is probably more efficient to incorporate any conversion into expression.</p>
</li>
</ul>
</blockquote>
</div>
<div class="section" id="example">
<h2>Example<a class="headerlink" href="#example" title="Permalink to this headline">¶</a></h2>
<p>Here is an example snippet showing basic and advanced use of the template features. It is part of the 6hrs.txt example template file, which generates an HTML table of 7 hourly readings (which should span 6 hours).</p>
<div class="highlight-python"><pre>#hourly#
#jump -6#
#loop 7#
  &lt;tr&gt;
    &lt;td&gt;#idx "%Y/%m/%d" "" "[None, x][x.hour == 0 or loop_count == 7]"#&lt;/td&gt;
    &lt;td&gt;#idx "%H%M %Z"#&lt;/td&gt;
    &lt;td&gt;#temp_out "%.1f °C"#&lt;/td&gt;
    &lt;td&gt;#hum_out "%d%%"#&lt;/td&gt;
    &lt;td&gt;#wind_dir "%s" "-" "wind_dir_text[x]"#&lt;/td&gt;
    &lt;td&gt;#wind_ave "%.0f mph" "" "x * 3.6 / 1.609344"#&lt;/td&gt;
    &lt;td&gt;#wind_gust "%.0f mph" "" "x * 3.6 / 1.609344"#&lt;/td&gt;
    &lt;td&gt;#rain "%0.1f mm"#&lt;/td&gt;
    &lt;td&gt;#rel_pressure "%.0f hPa"#, #pressure_trend "%s" "" "pressure_trend_text(x)"#&lt;/td&gt;
  &lt;/tr&gt;
#jump 1#
#endloop#</pre>
</div>
<p>The first three lines of this snippet do the following: select hourly data, jump back 6 hours, start a loop with a count of 7. A jump forward of one hour appears just before the end of the repeated segment. As this last jump (of one hour) happens each time round the loop, a sequence of 7 data readings will be output. The last line marks the end of the loop — everything between the <tt class="docutils literal"><span class="pre">#loop</span> <span class="pre">7#</span></tt> and <tt class="docutils literal"><span class="pre">#endloop#</span></tt> lines is output 7 times.</p>
<p>The <tt class="docutils literal"><span class="pre">#temp_out</span> <span class="pre">...#</span></tt>, <tt class="docutils literal"><span class="pre">#hum_out</span> <span class="pre">...#</span></tt>, <tt class="docutils literal"><span class="pre">#rain</span> <span class="pre">...#</span></tt> and <tt class="docutils literal"><span class="pre">#rel_pressure</span> <span class="pre">...#</span></tt> instructions show basic data output. They each use a <tt class="docutils literal"><span class="pre">fmt_string</span></tt> to format the data appropriately. The <tt class="docutils literal"><span class="pre">#wind_ave</span> <span class="pre">...#</span></tt> and <tt class="docutils literal"><span class="pre">#wind_gust</span> <span class="pre">...#</span></tt> instructions show how to use a conversion expression to convert m/s to mph.</p>
<p>The <tt class="docutils literal"><span class="pre">#wind_dir</span> <span class="pre">...#</span></tt> and <tt class="docutils literal"><span class="pre">#pressure_trend</span> <span class="pre">...#</span></tt> instructions show use of the built-in array <tt class="docutils literal"><span class="pre">wind_dir_text</span></tt> and function <tt class="docutils literal"><span class="pre">pressure_trend_text</span></tt> to convert numerical values into English text.</p>
<p>Finally we get to datetime values. The <tt class="docutils literal"><span class="pre">#idx</span> <span class="pre">&quot;%H%M&quot;#</span></tt> instruction simply outputs the time (in HHMM format) of the data&#8217;s index. The <tt class="docutils literal"><span class="pre">#idx</span> <span class="pre">&quot;%Y/%m/%d&quot;</span> <span class="pre">&quot;&quot;</span> <span class="pre">&quot;[None,</span> <span class="pre">x][x.hour</span> <span class="pre">==</span> <span class="pre">0</span> <span class="pre">or</span> <span class="pre">loop_count</span> <span class="pre">==</span> <span class="pre">7]&quot;#</span></tt> instruction is a bit more complicated. It outputs the date, but only on the first line or if the date has changed. It does this by indexing the array <tt class="docutils literal"><span class="pre">[None,</span> <span class="pre">x]</span></tt> with a boolean expression that is true when <tt class="docutils literal"><span class="pre">loop_count</span></tt> is 7 (i.e. on the first pass through the loop) or <tt class="docutils literal"><span class="pre">x.hour</span></tt> is zero (i.e. this is the first hour of the day).</p>
</div>
<div class="section" id="module-pywws.Template">
<span id="detailed-api"></span><h2>Detailed API<a class="headerlink" href="#module-pywws.Template" title="Permalink to this headline">¶</a></h2>
<p>Create text data file based on a template.</p>
<p>usage: python Template.py [options] data_dir template_file output_file
options are:</p>
<blockquote>
<table class="docutils option-list" frame="void" rules="none">
<col class="option" />
<col class="description" />
<tbody valign="top">
<tr><td class="option-group">
<kbd><span class="option">--help</span></kbd></td>
<td>display this help</td></tr>
</tbody>
</table>
</blockquote>
<p>data_dir is the root directory of the weather data
template_file is the template text source file
output_file is the name of the text file to be created</p>
<p class="rubric">Functions</p>
<table border="1" class="docutils">
<colgroup>
<col width="10%" />
<col width="90%" />
</colgroup>
<tbody valign="top">
<tr><td><a class="reference internal" href="#pywws.Template.main" title="pywws.Template.main"><tt class="xref py py-obj docutils literal"><span class="pre">main</span></tt></a>([argv])</td>
<td></td>
</tr>
</tbody>
</table>
<p class="rubric">Classes</p>
<table border="1" class="docutils">
<colgroup>
<col width="10%" />
<col width="90%" />
</colgroup>
<tbody valign="top">
<tr><td><a class="reference internal" href="#pywws.Template.Template" title="pywws.Template.Template"><tt class="xref py py-obj docutils literal"><span class="pre">Template</span></tt></a>(params,&nbsp;calib_data,&nbsp;hourly_data,&nbsp;...)</td>
<td></td>
</tr>
</tbody>
</table>
<dl class="class">
<dt id="pywws.Template.Template">
<em class="property">class </em><tt class="descclassname">pywws.Template.</tt><tt class="descname">Template</tt><big>(</big><em>params</em>, <em>calib_data</em>, <em>hourly_data</em>, <em>daily_data</em>, <em>monthly_data</em><big>)</big><a class="reference internal" href="../_modules/pywws/Template.html#Template"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Template.Template" title="Permalink to this definition">¶</a></dt>
<dd><dl class="method">
<dt id="pywws.Template.Template.process">
<tt class="descname">process</tt><big>(</big><em>live_data</em>, <em>template_file</em><big>)</big><a class="reference internal" href="../_modules/pywws/Template.html#Template.process"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Template.Template.process" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="pywws.Template.Template.make_text">
<tt class="descname">make_text</tt><big>(</big><em>template_file</em>, <em>live_data=None</em><big>)</big><a class="reference internal" href="../_modules/pywws/Template.html#Template.make_text"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Template.Template.make_text" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="method">
<dt id="pywws.Template.Template.make_file">
<tt class="descname">make_file</tt><big>(</big><em>template_file</em>, <em>output_file</em>, <em>live_data=None</em><big>)</big><a class="reference internal" href="../_modules/pywws/Template.html#Template.make_file"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Template.Template.make_file" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</dd></dl>

<dl class="function">
<dt id="pywws.Template.main">
<tt class="descclassname">pywws.Template.</tt><tt class="descname">main</tt><big>(</big><em>argv=None</em><big>)</big><a class="reference internal" href="../_modules/pywws/Template.html#main"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#pywws.Template.main" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">pywws.Template</a><ul>
<li><a class="reference internal" href="#introduction">Introduction</a></li>
<li><a class="reference internal" href="#processing-instructions">Processing instructions</a></li>
<li><a class="reference internal" href="#example">Example</a></li>
<li><a class="reference internal" href="#module-pywws.Template">Detailed API</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="pywws.WindRose.html"
                        title="previous chapter">pywws.WindRose</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="pywws.Forecast.html"
                        title="next chapter">pywws.Forecast</a></p>
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="pywws.Forecast.html" title="pywws.Forecast"
             >next</a> |</li>
        <li class="right" >
          <a href="pywws.WindRose.html" title="pywws.WindRose"
             >previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" >Python programs and modules</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2009-12, Jim Easterbrook.
      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.1.
    </div>
  </body>
</html>